package com.ruoyi.ss.card.domain.enums;

import lombok.Getter;

import java.util.Arrays;

import static com.ruoyi.common.constant.ServiceConstants.*;

/**
 * 交易结果
 * @author qzz
 * 2024/9/24
 */
@Getter
public enum CouponType {

    STORED_VALUE_CARD(COUPON_ORDER_TYPE_STORED_VALUE_CARD),
    HOUR_CARD(COUPON_ORDER_TYPE_HOUR_CARD),
    TIMES_CARD(COUPON_ORDER_TYPE_TIMES_CARD),
    GROUP_BUYING(COUPON_ORDER_TYPE_GROUP_BUYING_COUPON);

    private final String code;
    CouponType(String code) { this.code = code; }
    public static CouponType fromCode(String code) {
        return Arrays.stream(values())
                .filter(type -> type.code.equals(code))
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("未知卡券类型"));
    }
}


