package com.ruoyi.ss.userCard.domain;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 用户卡券对象 ss_user_card
 *
 * @author qzz
 * @date 2025-03-19
 */
@Data
public class UserCard extends BaseEntity{

    private static final long serialVersionUID = 1L;

    private Long recordId;

    @Excel(name = "领取人")
    @ApiModelProperty("领取人")
    private Long userId;

    @Excel(name = "卡券")
    @ApiModelProperty("卡券")
    private Long couponId;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "领取时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("领取时间")
    private LocalDateTime receiveTime;

    @Excel(name = "获取方式")
    @ApiModelProperty("获取方式")
    private String getMethod;

    @Excel(name = "订单号")
    @ApiModelProperty("订单号")
    private String orderNo;

    @Excel(name = "状态")
    @ApiModelProperty("状态")
    private String status;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "开始使用时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("开始使用时间")
    private LocalDateTime startTime;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "结束使用时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("结束使用时间")
    private LocalDateTime endTime;

    @ApiModelProperty("储值卡剩余金额")
    private BigDecimal storedAmount;

    @ApiModelProperty("次卡剩余次数")
    private Integer remainingTimes;

    @ApiModelProperty("小时卡剩余小时数")
    private Integer remainingHours;

    @ApiModelProperty("已使用次数")
    private Integer usedTimes;

    @ApiModelProperty("已使用金额")
    private BigDecimal usedAmount;

    @ApiModelProperty("已使用小时数")
    private Integer usedHours;

    // 新增字段：卡券归属类型
    @ApiModelProperty("卡券归属类型：1-平台卡；2-商户卡")
    private String cardType;

    @ApiModelProperty("类型：1-储值卡;2-小时卡;3-团购券;4-次卡")
    private String type;

}
